#ifndef PSPA_SEEN
#define  PSPA_SEEN


#include <list>

#include <Wt/WApplication>
#include <Wt/WEnvironment>
#include <Wt/WContainerWidget>
#include <Wt/WTextArea>
#include <Wt/WPanel>
#include <Wt/WComboBox>
#include <Wt/WPushButton>

#include "dataManager.h"

using namespace Wt;

/*
 * ESSAI PSPA
 */
class PspaApplication : public WApplication
{

typedef struct 
{
  WLineEdit* debut;
  WLineEdit*  fin;
  WComboBox* selection;
  WContainerWidget* ligneDeWidget;
} GWt_sectionToExecute;



 private :
  WTextArea* console_;
  dataManager* dtmanage_;
  WWidget* globalParam_;
  WWidget* beamLine_;
  WContainerWidget* leDessin_;

  WContainerWidget* contenuSections_;

  WPushButton *exec_go_;


  list<GWt_sectionToExecute*> selectedSections_;

  WWidget* createPalette();
  WWidget* createBeamLine();
  WWidget* createGlobalParamWidget();
  WWidget* createExecuteWidget();

  void createDragImage(const char *url, const char *smallurl,
                  const char *mimeType,
                       WContainerWidget *p,
                       WString name);


  void executer();
  void sauver();
  void restaurer();

  void addSectionToExecuteW();
  void deleteSectionToExecuteW();

  void checkSectionSelection();

  void disableSectionExecute();

  void faireDessin();

  void faireDessinTransport();


public:
  PspaApplication(const WEnvironment& env);
  inline dataManager* getDataManager() const 
  {
    return dtmanage_;
  }


  inline void addConsoleMessage(WString msg) {
    console_->setText 	(console_->text()+msg+"\n"); 
  }

  //  void addElemToGlobals();
  void updateSelections();

};

#endif
